package cz.zweistein.df.soundsense.gui;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map.Entry;

import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

import cz.zweistein.df.soundsense.output.sound.player.ChannelPlaybackCallback;
import cz.zweistein.df.soundsense.output.sound.player.ChannelThread;
import cz.zweistein.df.soundsense.output.sound.player.PlayerManager;

public class ChannelListAdapter implements ListModel, ChannelPlaybackCallback {

	private PlayerManager playerManager;
	
	private List<ListDataListener> listeners;

	public ChannelListAdapter(PlayerManager playerManager) {
		this.playerManager = playerManager;
		
		this.listeners = new ArrayList<ListDataListener>();

		this.playerManager.addChannelPlaybackCallback(this);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public Object getElementAt(int i) {
		return ((Entry<String, ChannelThread>)Arrays.asList(this.playerManager.getChannels().entrySet().toArray()).get(i)).getValue();
	}

	@Override
	public int getSize() {
		return this.playerManager.getChannels().size();
	}

	@Override
	public void addListDataListener(ListDataListener arg0) {
		this.listeners.add(arg0);
	}

	@Override
	public void removeListDataListener(ListDataListener arg0) {
		this.listeners.remove(arg0);
	}

	@Override
	public void changed() {
		for (ListDataListener listener : this.listeners) {
			listener.contentsChanged(new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 0, this.playerManager.getChannels().size()+1));
		}
	}

}
