package cz.zweistein.df.soundsense.input.file;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Logger;

import cz.zweistein.df.soundsense.input.Listener;
import cz.zweistein.df.soundsense.util.LoggerSource;

public class LogReader extends Listener {
	private static Logger logger = LoggerSource.logger;
	
	public LogReader(String logFile) throws IOException {
		this(logFile, true);
	}

	public LogReader(String logFile, boolean skip) throws IOException {
		
		FileInputStream in = new FileInputStream(logFile);
		// reading as MS-DOS Latin-1 alphabet
		InputStreamReader isr = new InputStreamReader(in, "Cp850");
		this.br = new BufferedReader(isr);
		
		if (skip) {
			long length = new File(logFile).length();
			logger.info("Skipping "+length+" bytes.");
			br.skip(length);
		}
		
	}

}
